#include "DxLib.h"
#include "Map.h"
#include "Collision.h"
#include "function.h"

void initialize()
{
	tileImgX = 0;
	playerImg = 0;
	enemyImg = 0;
}

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR lpCmdLine, int nCmdShow)
{
	//----------------------------------// 
	//{ݒ
	//----------------------------------// 

	ChangeWindowMode(TRUE);														//EBhE[hL
	SetMainWindowText("1Npev[g08");									//EBhE^Cg
	DxLib_Init();																//Cu
	SetDrawScreen(DX_SCREEN_BACK);												//v[hJn
	SetGraphMode(WINDOW_WIDTH, WINDOW_HEIGHT, COLOR_DEPTH);						//EBhETCYƃJ[w
	Map* map = new Map();														//^C}bv֐ǂݍ
	Collision* collision = new Collision();										//^CƂ̓蔻֐ǂݍ

	//----------------------------------// 
	//摜f[^ǂݍ
	//----------------------------------//

	startImg = LoadGraph("img/start.png");										//Jn摜v[h
	titleBgm = LoadSoundMem("sound/titleBgm.mp3");								//^Cgȃv[h
	centerBackgroundImg = LoadGraph("img/tiled.png");							//wi摜v[h
	winImg = LoadGraph("img/win.png");											//ʃv[h
	loseImg = LoadGraph("img/loose.png");										//skʃv[h
	shotImg = LoadGraph("img/shot.png");										//
	LoadDivGraph("img/player.png", 2, 2, 1, 30, 50, playerIdle);				//ҋ@[V摜v[h
	LoadDivGraph("img/playerRun.png", 4, 4, 1, 30, 50, playerRun);				//Aj摜v[h
	LoadDivGraph("img/playerDamaged.png", 2, 2, 1, 30, 50, playerDamaged);		//_[W摜v[h
	LoadDivGraph("img/jump.png", 4, 4, 1, 30, 50, playerJump);					//WvAj摜v[h
	LoadDivGraph("img/enemy.png", 4, 4, 1, 30, 30, enemyNormal);				//G@v[h
	LoadDivGraph("img/enemyDamaged.png",2,2,1,30,30,enemyDamaged);				//G@ev[h

	//----------------------------------// 
	//TEhf[^ǂݍ
	//----------------------------------//

	//playerJumpSound = LoadSoundMem("sound/jumps.mp3");							//Wvʉv[h
	//playerAttackedSound = LoadSoundMem("sound/yarares.wav");						//@ߖv[h
	//playerDamagedSound = LoadSoundMem("sound/yarares2.mp3");						//@ߖv[h
	//playerDamagedExplosion = LoadSoundMem("sound/playerDamagedExplosion.wav");	//v[h
	//explosion = LoadSoundMem("sound/explosion.mp3");								//v[h
	//thunderSound = LoadSoundMem("sound/thunder.mp3");								//̉v[h
	//thunderSound2 = LoadSoundMem("sound/thunder2.mp3");							//̉v[h
	//titleBgm = LoadSoundMem("sound/title.mp3");									//^Cgȃv[h
	//battleBgm = LoadSoundMem("sound/battle.mp3");									//퓬ȃv[h
	//winBgm = LoadSoundMem("sound/wins.mp3");										//ȃv[h
	//loseBgm = LoadSoundMem("sound/looses.mp3");									//skȃv[h

	while (1)
	{

		//----------------------------------// 
		//Q[
		//----------------------------------//

		while (!ProcessMessage() && gameStatus == INIT) 				//G[oԂ
		{
			ClearDrawScreen();											//`揉
			StopSoundMem(winBgm);										//Ȃ~߂	
			StopSoundMem(loseBgm);										//skȂ~߂	
			PlaySoundMem(titleBgm, DX_PLAYTYPE_BACK);					//^CgȂ𗬂
			playerX = FIRST_PLAYER_POSITION_X;							//v[[̏oʒûW
			playerY = FIRST_PLAYER_POSITION_Y;							//v[[̏oʒûW
			playerEndPositionX = PLAYER_END_POSITION_X;					//v[[̏I[ʒu
			enemyX = FIRST_ENEMY_POSITION_X;							//G̏oʒûW
			enemyY = FIRST_ENEMY_POSITION_Y;							//G̏oʒûW
			enemySpeedX = ENEMY_SPEED_X;								//G̉̑x
			enemySpeedY = ENEMY_SPEED_Y;								//G̏c̑x
			centerBackGroundImgX = BACKGROUND_IMG_CENTER_POSITION_X;	//wîW
			centerBackgroungImgY = BACKGROUND_IMG_CENTER_POSITION_Y;	//wîW
			backgroundImgEndPositionX = BACKGROUND_IMG_END_POSITION_X;	//wȉI[W
			bgDefaultSpeed = BACKGROUND_DEFAULT_SPEED;					//wi̊{Xs[h
			collisionBoxSpeedX = FIRST_SPEED_VALUE;						//蔻ʒũXN[x
			gravity = GRAVITY;											//d͒l
			jumpPower = JUMP_MAX_POWER;									//Wv
			firstSpeed = FIRST_SPEED_VALUE;								//ŏ̑x
			hitpoint = HITPOINT_MAX_VALUE;								//qbg|Cg
			score = FIRST_SCORE_VALUE;									//XRA
			addCoefficient = COEFFICIENT_CONTROL_VALUE;					//GWv␳W
			gameStatus = TITLE;											//Q[Ԃ^Cgɂ
			ScreenFlip();												//ʍXV
		}

		//----------------------------------// 
		//^Cg
		//----------------------------------//

		while (!ProcessMessage() && gameStatus == TITLE) 			//G[oԂ^Cg
		{
			ClearDrawScreen();										//`揉
			DrawGraph(0, 0, startImg, FALSE);						//wi\
			SetFontSize(24);										//tHgTCYw
			if (CheckHitKey(KEY_INPUT_RETURN)) 						//^[L[ꂽ
			{
				StopSoundMem(titleBgm);								//^CgBGM~߂
				gameStatus = PLAY;									//Q[vCԂɂ
				PlaySoundMem(battleBgm, DX_PLAYTYPE_BACK);			//ogBGMĐ
			}
			ScreenFlip();											//ʍXV
			initialize();
		}

		//----------------------------------//
		//Q[C
		//----------------------------------//

		while (!ProcessMessage() && gameStatus == PLAY)			//G[oԂvC
		{
			//----------------------------------//
			//`揉
			//----------------------------------//	
			ClearDrawScreen();									//`揉
			playerImg = playerIdle[frameCount2];				//@摜͑ҋ@[V
			enemyImg = enemyNormal[frameCount4];				//G@摜̓m[}摜

			//----------------------------------// 
			//@Ɣwïړ
			//----------------------------------// 

			//@Eړ`
			if (CheckHitKey(KEY_INPUT_RIGHT) == 1)							//EL[ꂽ
			{
				playerReverse = FALSE;										//]Ȃ
				playerImg = playerRun[frameCount4];							//v[[摜͑ĂAj[V
				if (playerX + rightPlayerSpeedX >= 600 && centerBackGroundImgX >= backgroundImgEndPositionX)	//v[[ʒ܂ŗ
				{
					rightPlayerSpeedX = 0;									//Xs[h[ɂ
					tileSpeedX = firstSpeed;								//^C̈ړx̓ftHg
					collisionBoxSpeedX = firstSpeed;						//蔻̈ړx̓ftHg
					tileImgX -= tileSpeedX;									//^CɈړ
					collisionBoxX -= collisionBoxSpeedX;					//蔻Ɉړ
					centerBackGroundImgX -= backgroundSpeedX;				//wi摜ړ
				}
				else
				{
					rightPlayerSpeedX = firstSpeed;							//v[[̈ړx̓ftHg
					playerX += rightPlayerSpeedX;							//v[[͈ړxňړ
					tileSpeedX = 0;											//^Cړx[
					tileImgX -= tileSpeedX;									//^C̏ꏊm
					collisionBoxSpeedX = 0;									//蔻͈ړȂ
					collisionBoxX -= collisionBoxSpeedX;					//蔻̈ʒum
					backgroundSpeedX = bgDefaultSpeed;						//wiړx̓ftHg
				}
				if (playerX + rightPlayerSpeedX >= playerEndPositionX)		//v[[I[̈ʒu܂ŗ
				{
					rightPlayerSpeedX = 0;									//Eړx[
					playerX = playerEndPositionX;							//v[[I[ʒu
					tileImgX = -3840;										//^C̏ꏊm
					collisionBoxX = -3840;									//蔻̈ʒum
					backgroundSpeedX = 0;									//wiړx[
					centerBackGroundImgX = -3840;							//wïʒum
				}
				if (playerX >= 1760)
				{
					gameStatus = CLEAR;
					StopSoundMem(explosion);												//Q[BGM~߂
					StopSoundMem(battleBgm);												//Q[BGM~߂
					PlaySoundMem(loseBgm, DX_PLAYTYPE_BACK);								// BGMĐ
				}
				if (playerY >= 980)
				{
					gameStatus = OVER;
					StopSoundMem(explosion);												//Q[BGM~߂
					StopSoundMem(battleBgm);												//Q[BGM~߂
					PlaySoundMem(loseBgm, DX_PLAYTYPE_BACK);								// BGMĐ
				}
			}

			//@ړ`
			if (CheckHitKey(KEY_INPUT_LEFT) == 1)												//L[ꂽ
			{
				playerReverse = TRUE;															//]
				playerX += leftPlayerSpeedX;													//@ړ
				playerImg = playerRun[frameCount4];												//@摜̓
			}
			if (playerX + leftPlayerSpeedX <= 40)												//ɓ
			{
				leftPlayerSpeedX = 0;															//~
			}
			else																				//łȂ
			{
				leftPlayerSpeedX = -firstSpeed;													//ɕA
			}

			//Wv
			if (CheckHitKey(KEY_INPUT_B) == 1 && jumpFlag == false)								//B{^ꂽ
			{
				jumpFlag = true;																//Wv\ɂ
				playerYPrev = playerY;															//OWɌݍWۑ
				playerY -= jumpPower;															//Wv͂ōWړ
				PlaySoundMem(playerJumpSound, DX_PLAYTYPE_BACK);								//Wvʉ炷
			}
			if (jumpFlag == true)																//Wv\Ȃ
			{
				const int maxVy = 18;
				int vy;
				playerImg = playerJump[frameCount4];											//@摜̓Wv
				playerYTemp = playerY;															//݂yWꎞۑ

				vy = (playerY - playerYPrev) + gravity;                                         // y̑x߂
				vy = (vy > maxVy) ? maxVy : vy;

				playerY += vy;			                                 						//݂yWOyWƂ̍ďd͒l
				playerYPrev = playerYTemp;														//O̍WƂĈꎞۑ̍Wۑ				
			}

			//^CƂ̓蔻菈
			collision->ColAll();

			//----------------------------------// 
			//G@ړ
			//----------------------------------//
			enemyX -= enemySpeedX;																//G@ړ`
			if (enemyX <= -10)																	//ɓ
			{
				enemySpeedX = -enemySpeedX;														//]
				enemySpeedY = jumpPower - firstSpeed / addCoefficient;							//␳
				enemySpeedY = -enemySpeedY;														//]
			}
			if (enemyX >= 710)																	//Eɓ
			{
				enemySpeedX = -enemySpeedX;														//]
				enemySpeedY = jumpPower - firstSpeed / addCoefficient;							//␳
				enemySpeedY = -enemySpeedY;														//]
			}

			//eˏ
			if (CheckHitKey(KEY_INPUT_SPACE) == 1)												//Xy[XL[ꂽ玞
			{
				if (!shotFlag)																	//ˉ\łȂ
				{
					shotFlag = true;															//ˏԂɂ
					shotX = playerX;															//@̈ʒuɃZbg
					shotY = playerY;															//@̈ʒuɃZbg
				}
			}
			if (CheckHitKey(KEY_INPUT_LEFT) == 1)												//L[ꂽ
			{
				shotSpeed = -50;																//ɑx30
			}
			if (CheckHitKey(KEY_INPUT_RIGHT) == 1)												//EL[ꂽ
			{
				shotSpeed = 50;																	//Eɑx30
			}

			//eʊOɏo珉
			if (shotFlag)																		//ˏԂȂ
			{
				shotX += shotSpeed;																//eړ
				if (shotX < 0 || shotX > 1920)													//ʊOɏo
				{
					shotFlag = false;															//ˏԂ
				}
			}

			//G@ƒe̓蔻
			if (shotFlag)																		//eˏԂȂ
			{
				if (shotX + 40 > enemyX + 20 && shotX < enemyX + 30 && shotY + 30 > enemyY + 30 && shotY < enemyY + 30) //蔻菈
				{
					enemyImg = enemyDamaged[frameCount2];										//e摜ւ		  
					shotFlag = false;															//ˏ
					score += 100;																//XRAZ
				}
			}

			//G@Ǝ@̓蔻
			if (enemyAttackFlag)																//蔻\Ȃ
			{
				if (playerX + 50 > enemyX + 50 && playerX + 30 < enemyX + 50 && playerY + 30 > enemyY + 100 && playerY + 30 < enemyY + 100) //蔻菈
				{
					playerImg = playerDamaged[frameCount2];										//@Փˉ摜Ɠւ
					hitpoint -= 20;																//qbg|CgZ
					enemyAttackFlag = false;													//蔻薳ɂ
					PlaySoundMem(playerAttackedSound, DX_PLAYTYPE_BACK);						//@ߖ
					PlaySoundMem(playerDamagedExplosion, DX_PLAYTYPE_BACK);						//炷
					if (hitpoint <= 0)															//qbg|CgOɂȂ
					{
						gameStatus = OVER;														//Q[I[o[
						StopSoundMem(explosion);												//Q[BGM~߂
						StopSoundMem(battleBgm);												//Q[BGM~߂
						PlaySoundMem(loseBgm, DX_PLAYTYPE_BACK);								// BGMĐ
					}
				}
			}
			if (!enemyAttackFlag)																//蔻薳Ȃ
			{
				enemyAttackFlag = true;															//蔻Lɂ
			}

			//----------------------------------// 
			//`揈
			//----------------------------------// 
			timerCount = GetNowCount();				//^C}[Ōݎ擾
			frameCount = timerCount % 4;			//Aj[ṼR}o߂Ƀ^C}[4Ŋ
			frameCount4 = timerCount / 150 % 4;		//PAj[VPbɂ邽߂ɁA^C}[125ŊĕbɂĂ4ŊăR}o
			frameCount2 = timerCount / 150 % 2;		//PAj[VPbɂ邽߂ɁA^C}[125ŊĕbɂĂ2ŊăR}o
			DrawGraph(centerBackGroundImgX, centerBackgroungImgY, centerBackgroundImg, FALSE);	//wi`
			map->All();																			//^Cwi`
			collision->ColAll();																//}bv^CƂ̓蔻
			DrawRotaGraph(playerX, playerY, 2.0f, 0, playerImg, TRUE, playerReverse);			//@`
			DrawRotaGraph(enemyX, enemyY, 2.0f, 0, enemyImg, TRUE, enemyReverse);				//G@`			
			if (shotFlag)																		//ˏԂȂ
			{
				DrawGraph(shotX, shotY, shotImg, TRUE);				//`	
			}
			SetFontSize(30);																	//tHgTCYw
			DrawFormatString(0, 0, GetColor(255, 255, 255), "SCORE : %d", score);				//_\
			DrawFormatString(200, 0, GetColor(255, 0, 0), "HITPOINT : %d", hitpoint);			//qbg|Cg\

			/*DrawCircle(pX+1, pY+1, 3, GetColor(255, 0, 0));
			DrawCircle(pX +30 , pY + 30 , 3, GetColor(255, 0, 0));
			DrawFormatString(0, 200, GetColor(255, 255, 255), "%d", collisionBoxX);
			DrawFormatString(pX + 15, pY + 30, GetColor(255, 255, 255), "(%d, %d)", pX + 15, pY + 30);*/

			if (CheckHitKey(KEY_INPUT_ESCAPE))
			{
				gameStatus = INIT;
			}
			ScreenFlip();					//ʍXV
		}

		WaitTimer(300);					//Jnx

		//----------------------------------//
		//Q[I[o[
		//----------------------------------//

		while (!ProcessMessage() && gameStatus == OVER)
		{
			ClearDrawScreen();								//`揉
			DrawGraph(0, 0, loseImg, FALSE);
			DrawString(800, 1000, "Xy[XL[Ń^Cg", GetColor(0, 0, 0));
			if (CheckHitKey(KEY_INPUT_SPACE))
			{
				gameStatus = INIT;							//Q[
			}
			ScreenFlip();									//ʍXV
		}

		WaitTimer(300);//Jnx

		//----------------------------------//
		//Q[NA
		//----------------------------------//

		while (!ProcessMessage() && gameStatus == CLEAR)
		{
			ClearDrawScreen();								//`揉

			DrawGraph(0, 0, winImg, FALSE);
			DrawString(800, 1000, "Xy[XL[Ń^Cg", GetColor(0, 0, 0));
			if (CheckHitKey(KEY_INPUT_SPACE))
			{
				gameStatus = INIT;							//^[L[Ń^Cg
			}
			ScreenFlip();									//ʍXV
		}

		WaitTimer(300);										//Jnx

		//----------------------------------//
		//[eB
		//----------------------------------//

		if (CheckHitKey(KEY_INPUT_ESCAPE) == 1)
		{
			gameStatus = INIT;
			break;											//[v甲
		}
	}

	DxLib_End();											//Q[I
	return 0;
}
